package modules.oresme;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;

public class OresmeCanvas extends JComponent {
  BufferedImage bimg;

  int w = 600;
  int h = 400;

  long paintNum = 0;

  public OresmeCanvas(Color bg) {
    super();

    //setDoubleBuffered(true);
    
    setOpaque(true);
    //setMinimumSize(new Dimension(w,h));
    setPreferredSize(new Dimension(w,h));
    //setMaximumSize(new Dimension(w,h));
    
    setBackground(bg);
    //setBackground(Color.orange);
    //bimg = new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);
    /*
    bimg = (BufferedImage) createImage(w,h);
    System.out.println(bimg);
    Graphics2D g2d = bimg.createGraphics();
    g2d.setBackground(getBackground());
    g2d.clearRect(0,0,w,h);
    g2d.dispose();
    repaint();
    validate();
    */
  }


  UnitPart r = new UnitPart("\u03b1",2f);
  //Rectangle2D.Float r = new Rectangle2D.Float(0,40,40,40);
  boolean left = false;
  float step = 5;

  public void draw(Graphics2D g) {
    r.y = 40;

    if(left) {
      if(r.x-step >= 0)
        r.x -= step;
      else
        left = false;
    } else {
      if(r.x+step <= 200)
        r.x += step;
      else
        left = true;
    }

    r.draw(g);
    //g.draw(r);
  }

  
  public void paintCanvas() {
    Graphics g;
    g = this.getGraphics();
    if((g != null) && (bimg != null)) {
      g.drawImage(bimg,0,0,null);
      g.dispose();
    }
  }

  public void paintComponent(Graphics g) {
    /*
    Graphics2D g2d = getImageGraphics(true);
    draw(g2d);
    g2d.dispose();

    if(bimg == null)
      getImageGraphics().dispose();
    */

    /*
    System.out.println("paintComponent" + (paintNum++));

    w = (getWidth() > 0) ? getWidth() : 1;
    h = (getHeight() > 0) ? getHeight() : 1;

    if(bimg == null || 
       bimg.getWidth() != w || 
       bimg.getHeight() != h) {
      BufferedImage t = bimg;
      bimg = (BufferedImage) createImage(w,h);    

      Graphics2D g2 = bimg.createGraphics();
      g2.setBackground(getBackground());
      g2.clearRect(0,0,w,h);

      if(t != null)
        g2.drawImage(t,0,0,null);
    }
    */

    if(bimg != null)
      g.drawImage(bimg,0,0,null);
  }

  public Graphics2D getImageGraphics() {
    return getImageGraphics(true);
  }

  public Graphics2D getImageGraphics(boolean clear) {
    Graphics2D g2d = null;
    //if(bimg == null || bimg.getWidth() != w || bimg.getHeight() != h)
    //  bimg = new BufferedImage(w,h,BufferedImage.TYPE_INT_RGB);

    /*
    w = (getWidth() > 0) ? getWidth() : 1;
    h = (getHeight() > 0) ? getHeight() : 1;

    if(bimg == null || 
       bimg.getWidth() != w || 
       bimg.getHeight() != h)
    */
    if(bimg == null)
      bimg = (BufferedImage) createImage(w,h);
    
    g2d = bimg.createGraphics();
    
    if(clear) {
      g2d.setBackground(getBackground());
      g2d.clearRect(0,0,w,h);
      //g2d.clearRect(300,345,250,50);
    }
    
    g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
    g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
                         RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
    return g2d;
  }

}