package modules.summation;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;

import vcp.utilities.ScrollableTextArea;
import vcp.mathnotation.*;
import vcp.animation.*;

import info.clearthought.layout.TableLayout;

public class SummationVisualization extends JPanel 
  implements vcp.utilities.ScrollableTextAreaConstants {
  
  private static final int strokeWidth = 3;
  private static final Stroke stroke = new BasicStroke(strokeWidth);

  ControlPanel cp;

  SquareGrid sg;

  ScrollableTextArea details;

  JLabel ilabel, jlabel, identLabel, summandLabel, summandTotal, tempTotal;

  //FastLabel sumLabel;
  JLabel[] sumLabel;
  JLabel[] sumTotal;

  JPanel sumPanel;

  ImageIcon[] sumExpression;

  public SummationVisualization() {
    sumExpression = new ImageIcon[6];

    double h = 0;
    MathExpression expr = 
      MathSymbol.getSuperscript("(3\u22121+1)","2").toMathExpression(25f);
    sumExpression[0] = new ImageIcon(expr.toImage(10));
    expr = MathSymbol.getTextSymbol
      ("2(3\u22121+1)(3-2+1)").toMathExpression(25f);
    sumExpression[1] = new ImageIcon(expr.toImage(10));
    expr = MathSymbol.getTextSymbol
      ("2(3\u22121+1)(3-3+1)").toMathExpression(25f);
    sumExpression[2] = new ImageIcon(expr.toImage(10));
    expr = MathSymbol.getSuperscript("(3\u22122+1)","2").toMathExpression(25f);
    sumExpression[3] = new ImageIcon(expr.toImage(10));
    expr = MathSymbol.getTextSymbol
      ("2(3\u22122+1)(3-3+1)").toMathExpression(25f);
    sumExpression[4] = new ImageIcon(expr.toImage(10));
    expr = MathSymbol.getSuperscript("(3\u22123+1)","2").toMathExpression(25f);
    sumExpression[5] = new ImageIcon(expr.toImage(10));

    for(int i = 0; i < 6; i++)
      if(sumExpression[i].getIconHeight() > h)
        h = sumExpression[i].getIconHeight() + 8;

    setLayout(new TableLayout(new double[][]
      {{TableLayout.FILL,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.FILL},
       {TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        h,
        //TableLayout.PREFERRED,
        TableLayout.FILL,
        TableLayout.PREFERRED,}}));

    sg = new SquareGrid();

    cp = new SliderControlPanel();

    details = new ScrollableTextArea();
    details.getJScrollPane().setPreferredSize(new java.awt.Dimension(20,100));
    details.setMargins(6);

    new SummationAnimation();

    expr = MathSymbol.getSummationSymbol
      ("i = 1","3",MathSymbol.getBrackets
       (new MathExpression
        (new MathSymbol[]
          {MathSymbol.getSuperscript
           (MathSymbol.getTextSymbol("(3\u2212i+1)").toMathExpression(),"2"),
           MathSymbol.getTextSymbol("+"),
           MathSymbol.getSummationSymbol
           ("j = i+1","3",
            MathSymbol.getTextSymbol
            ("2(3\u2212i+1)(3\u2212j+1)").toMathExpression(),"sum")        
          },1f)).toMathExpression(),"SUM!").toMathExpression(20f);

    Font f = new Font("Serif",Font.PLAIN,20);

    ilabel = new JLabel("i = # ");
    ilabel.setFont(f);
    jlabel = new JLabel("j = # ");
    jlabel.setFont(f);

    identLabel = new JLabel(new ImageIcon(expr.toImage(10)));
    identLabel.setMinimumSize(identLabel.getPreferredSize());
    identLabel.setMaximumSize(identLabel.getPreferredSize());
    identLabel.setPreferredSize(identLabel.getPreferredSize());
    identLabel.setSize(identLabel.getPreferredSize());
    //identLabel.setBorder(new javax.swing.border.LineBorder(Color.black,1));
    summandLabel = new JLabel();
    summandTotal = new JLabel();
    //sumLabel = new FastLabel("M",getBackground());
    sumLabel = new JLabel[6];
    f = f.deriveFont(14f);
    summandLabel.setFont(f);
    summandTotal.setFont(f);
    tempTotal = new JLabel();
    tempTotal.setFont(f);

    JPanel summandPanel = new JPanel();
    summandPanel.add(summandLabel);
    summandPanel.add(summandTotal);

    for(int i = 0; i < 6; i++) {
      sumLabel[i] = new JLabel("");
      sumLabel[i].setFont(f);
    }

    sumTotal = new JLabel[] {
      new JLabel("27"),
      new JLabel("8"),
      new JLabel("1")     
    };
    
    sumTotal[0].setVisible(false);
    sumTotal[0].setFont(f);
    sumTotal[1].setVisible(false);
    sumTotal[1].setFont(f);
    sumTotal[2].setVisible(false);
    sumTotal[2].setFont(f);

    ilabel.setVisible(false);
    jlabel.setVisible(false);

    TableLayout tl;
    sumPanel = new JPanel(tl = new TableLayout(new double[][]
      {{TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED},
       {TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED}}));

    tl.setVGap(5);
    tl.setHGap(5);

    sumPanel.add(sumLabel[0],"0,0,r,b");
    sumPanel.add(new JLabel("+"),"1,0,r,b");
    sumPanel.add(sumLabel[1],"2,0,r,b");
    sumPanel.add(new JLabel("+"),"3,0,r,b");
    sumPanel.add(sumLabel[2],"4,0,r,b");
    sumPanel.add(new JLabel("="),"5,0,r,b");
    sumPanel.add(sumTotal[0],"6,0,r,b");
    sumPanel.add(sumLabel[3],"2,1,r,b");
    sumPanel.add(new JLabel("+"),"3,1,r,b");
    sumPanel.add(sumLabel[4],"4,1,r,b");
    sumPanel.add(new JLabel("="),"5,1,r,b");
    sumPanel.add(sumTotal[1],"6,1,r,b");
    sumPanel.add(sumLabel[5],"4,2,r,b");
    sumPanel.add(new JLabel("="),"5,2,r,b");
    sumPanel.add(sumTotal[2],"6,2,r,b");

    expr = new MathExpression
      (new MathSymbol[]
        {MathSymbol.getSummationSymbol
         ("k=1","n",
          MathSymbol.getSuperscript("k","3").toMathExpression(),
          "sum of k^3 with k = 1 to n"),
         MathSymbol.getTextSymbol("="),
         MathSymbol.getSuperscript
         (MathSymbol.getParens
          (MathSymbol.getSummationSymbol("k=1","n","k",
                                         "sum of k where k = 1 to n")
           .toMathExpression()).toMathExpression(),"2")},15f);
      
    JLabel identity = new JLabel("The Identity:",
                                 new ImageIcon(expr.toImage(10)),
                                 JLabel.CENTER);
    identity.setVerticalTextPosition(JLabel.TOP);
    identity.setHorizontalTextPosition(JLabel.CENTER);

    add(identity,"0,0,0,3,l,b");

    add(identLabel,"1,0,3,0,c,c");
    add(ilabel,"1,1,c,c");
    add(jlabel,"1,2,c,c");
    add(sumPanel,"3,1,3,2,c,c");
    add(summandPanel,"1,3,3,3,c,c");
    add(sg,"2,1,2,2,c,c");
    add(details.getJScrollPane(),"0,4,4,4");
    add(cp,"0,5,4,5");
  }

  private class SquareGrid extends AnimationCanvas {
    int hx,hy,hw,hh;
    boolean highlight;

    public SquareGrid() {
      super(200,200,SummationVisualization.this.getBackground());
    }

    public void addNotify() {
      super.addNotify();

      paintCanvas();
    }

    public void paintCanvas() {
      Graphics2D g2 = getImageGraphics(false);

      g2.setStroke(stroke);

      g2.setColor(Color.black);

      float sh = strokeWidth/2f;

      float div = (w-strokeWidth)/3f;


      g2.draw(new Rectangle2D.Float(sh,sh,
                                    w-strokeWidth,
                                    h-strokeWidth));

      g2.draw(new Line2D.Float(sh+div,0,sh+div,h));
      g2.draw(new Line2D.Float(sh+2*div,0,sh+2*div,h));
      g2.draw(new Line2D.Float(0,sh+div,w,sh+div));
      g2.draw(new Line2D.Float(0,sh+2*div,w,sh+2*div));


      if(highlight) {
        float x0 = w-sh;
        float y0 = sh-div*hh;

        g2.setColor(Color.cyan);
        g2.draw(new Rectangle2D.Float(x0 - div*hx, y0 + div*hy,
                                      div*hw,div*hh));
      }

      g2.dispose();

      super.paintCanvas();
    }

    public void highlight(int xa, int ya, int wa, int ha) {
      hx = xa;
      hy = ya;
      hw = wa;
      hh = ha;
      highlight = true;
      repaint();
    }

    public void unhighlight() {
      highlight = false;
      repaint();
    }
  }

  private class SummationAnimation extends Animation {
    int count;
    int sli;

    public SummationAnimation() {
      super(cp,1000,200,800);

      setPartArray(new AnimationPart[]
        {
          new Part0(),
          new Part1(),
          new Part2(),
          new Part3(),
          new Part4(),
          new Part5(),
          new Part6(),
          new Part7(),
          new Part8(),
        });
    }

    private class Part0 implements AnimationPart {
      public void animate() {
        details.setContent("We begin with the left-hand side by counting all the possible locations for a rectangle of a certain size. In the visualization, the current dimensions of the rectangle being counted will appear to the left of the grid where i is the dimension of the smaller side and j is the dimension of the other side. The term of the summation that is being counted will appear below the grid. A running total of the number of rectangles for each i is located to the right of the grid.");
        ilabel.setText("i = 1");
        ilabel.setVisible(true);
      }
    }

    private void firstCount(int i) {
      ilabel.setText("i = " + i);
      jlabel.setVisible(true);
      for(int j = i; j <= 3; j++, sli++) {
        count = 0;
        summandLabel.setIcon(sumExpression[sli]);
        jlabel.setText("j = " + j);
        if(i != j)
          for(int y = j; y <= 3; y++) 
            for(int x = i; x <= 3; x++) {
              sg.highlight(x,y,i,j);
              sg.paintCanvas();
              sumLabel[sli].setText(++count + "");
              sleep();
            }
        
        for(int x = j; x <= 3; x++)
          for(int y = i; y <= 3; y++) {
            sg.highlight(x,y,j,i);
            sg.paintCanvas();
            sumLabel[sli].setText(++count + "");
            sleep();
          }      
      }
      sumTotal[i-1].setVisible(true);
      sg.unhighlight();
      sg.paintCanvas();
    }

    private void secondCount(int x) {
      ilabel.setText("p = " + x);
      jlabel.setVisible(true);
      for(int y = 1; y <= 3; y++) {
        jlabel.setText("q = " + y);
        int tcount = 0;
        for(int i = 1; i <= x; i++)
          for(int j = 1; j <= y; j++) {
            ++count;
            tempTotal.setText(" Rectangles at (" + x + ", " + y + "): " + 
                              (++tcount));
            sg.highlight(x,y,i,j);
            sg.paintCanvas();
            sleep();
          }
        if((x != 1) || (y != 1))
          summandLabel.setText(summandLabel.getText() + " + ");
        summandLabel.setText(summandLabel.getText() + x + "\u00b7" + y);
        summandTotal.setText("= " + count);
      }

      sg.unhighlight();
      sg.paintCanvas();
    }

    private class Part1 implements AnimationPart {
      public void animate() {
        details.append("Start with i = 1.",NEWLINES|SET_MARK|SCROLL);
        jlabel.setText("j = 1");

        jlabel.setVisible(true);

        count = 0;
        sli = 0;
        
        firstCount(1);
        details.append("Next, i = 2.",NEWLINES|SET_MARK|SCROLL);
        ilabel.setText("i = 2");
        jlabel.setVisible(false);
      }
    }

    private class Part2 implements AnimationPart {
      public void animate() {
        firstCount(2);
        details.append("Last, i = 3.",NEWLINES|SET_MARK|SCROLL);
        ilabel.setText("i = 3");
        jlabel.setVisible(false);
      }
    }

    private class Part3 implements AnimationPart {
      public void animate() {
        firstCount(3);

        details.append("Notice that all the terms in the following two expressions are equivalent.",SET_MARK|NEWLINES);

        details.append
          (MathSymbol.getTextSymbol("27 + 8 + 1 = 36").toMathExpression(20f));
        details.append
          (new MathExpression
           (new MathSymbol[]
             {MathSymbol.getSuperscript("3","3"),
              MathSymbol.getTextSymbol("+"),
              MathSymbol.getSuperscript("2","3"),
              MathSymbol.getTextSymbol("+"),
              MathSymbol.getSuperscript("1","3"),
              MathSymbol.getTextSymbol("="),
              MathSymbol.getSummationSymbol
              ("k=1","3",
               MathSymbol.getSuperscript("k","3").toMathExpression(),
               "sum of k^3 with k = 1 to 3")},20f),SCROLL);
      }
    }

    private class Part4 implements AnimationPart {
      public void animate() {
        details.append("Now, we will count the right side of the identity by counting the number of rectangles with their lower-left corner at (p,q). (These coordinates are explained in the exposition.) The values of p and q will appear on the left. The number of rectangles at each coordinate will appear to the right of the grid. The summands will appear below the grid with a running total of the number of rectangles.",
                       SET_MARK|SCROLL);
        sumPanel.setVisible(false);
        ilabel.setVisible(false);
        jlabel.setVisible(false);
        summandLabel.setVisible(false);

        ilabel.setText("p = 1");
        ilabel.setVisible(true);

        MathExpression expr = 
          (MathSymbol.getSummationSymbol
           ("p=1","3",
            MathSymbol.getSummationSymbol
            ("q=1","3",
             MathSymbol.getTextSymbol("pq").toMathExpression(),"sum")
            .toMathExpression(),"sum").toMathExpression(20f));
        
        identLabel.setIcon(new ImageIcon(expr.toImage(10)));

      }
    }

    private class Part5 implements AnimationPart {
      public void animate() {
        details.append("Start with p = 1.",SET_MARK|NEWLINES|SCROLL);
        jlabel.setText("q = 1");
        summandLabel.setIcon(null);
        jlabel.setVisible(true);
        summandLabel.setVisible(true);
        summandTotal.setText(" = ");

        SummationVisualization.this.remove(sumPanel);
        SummationVisualization.this.add(tempTotal,"3,1,3,2,c,c");
        SummationVisualization.this.validate();
        
        count = 0;

        secondCount(1);
        details.append("Next, p = 2.",NEWLINES|SET_MARK|SCROLL);  
        ilabel.setText("p = 2");
        jlabel.setVisible(false);
      }
    }

    private class Part6 implements AnimationPart {
      public void animate() {
        secondCount(2);
        details.append("Last, p = 3.",NEWLINES|SET_MARK|SCROLL);
        ilabel.setText("p = 3");
        jlabel.setVisible(false);
      }
    }

    private class Part7 implements AnimationPart {
      public void animate() {
        secondCount(3);

        details.append("Notice that the second way of counting is equivalent to the following expressions",NEWLINES|SET_MARK);

        details.append
          (new MathExpression
           (new MathSymbol[]
             {MathSymbol.getTextSymbol("1\u00b71 + 1\u00b72 + 1\u00b73 + 2\u00b71 + 2\u00b72 + 2\u00b73 + 3\u00b71 + 3\u00b72 + 3\u00b73"),
              MathSymbol.getTextSymbol("=")},20f));

        details.append
          (new MathExpression
           (new MathSymbol[]
             {MathSymbol.getTextSymbol("(1+2+3)(1+2+3)"),
              MathSymbol.getTextSymbol("="),
              MathSymbol.getSuperscript("(1+2+3)","2"),
              MathSymbol.getTextSymbol("="),
              MathSymbol.getSuperscript
              (MathSymbol.getParens
               (MathSymbol.getSummationSymbol("k=1","3","k",
                                             "sum of k where k = 1 to 3")
                .toMathExpression()).toMathExpression(),"2")},20f),SCROLL);        
      }
    }

    private class Part8 implements AnimationPart {
      public void animate() {
        ilabel.setVisible(false);
        jlabel.setVisible(false);
        summandLabel.setVisible(false);
        summandTotal.setVisible(false);
        identLabel.setVisible(false);
        tempTotal.setVisible(false);

        details.append("It is clear that in this example,",SET_MARK|NEWLINES);

        details.append
          (new MathExpression
           (new MathSymbol[]
             {MathSymbol.getSummationSymbol
              ("k=1","3",
               MathSymbol.getSuperscript("k","3").toMathExpression(),
               "sum of k^3 with k = 1 to 3"),
              MathSymbol.getTextSymbol("="),
              MathSymbol.getTextSymbol("36"),
              MathSymbol.getTextSymbol("="),
              MathSymbol.getSuperscript
              (MathSymbol.getParens
               (MathSymbol.getSummationSymbol("k=1","3","k",
                                             "sum of k where k = 1 to 3")
                .toMathExpression()).toMathExpression(),"2")},20f),SCROLL);
      }
    }


  }

}
