package vcp;

import javax.swing.*;
import java.io.*;

import vcp.platform.Module;
import vcp.platform.ModuleClassLoader;

/**
 * This is a class which can be used to test module visualizations
 * without having to load them in the actual VCP application. Simply
 * include the module package name as an argument on the command line.
 *
 * @author phil kaasa
 * @version 1.0
 */
public class ModuleTester extends JFrame {
  public ModuleTester(String moduleName) 
    throws ClassNotFoundException,InstantiationException,
           IllegalAccessException,FileNotFoundException,
           IOException {

    super(moduleName);

    new VCP(null,false);

    //System.out.println(System.getProperty("user.dir"));

    System.setProperty
      ("user.dir",
       System.getProperty("user.dir") + "/vcp");

    //System.out.println(System.getProperty("user.dir"));
    
    Module module;

    InputStream is = new FileInputStream
      ("vcp/modules/" + moduleName + "/module.cfg");
    module = new Module(moduleName);
    module.load(is);     

    JPanel mp = (JPanel) (new ModuleClassLoader("vcp/")).findClass
      (module.getProperty("main.class")).newInstance();
    
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    getContentPane().add(mp);
    pack();
    setVisible(true);
  }

  public static void main(String[] args) {
    try {
      new ModuleTester(args[0]);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}