package vcp.animation;

/**
 * This is an interfaces that parts or sections of an animation must
 * implement. It only has one required method.
 *
 * @author phil kaasa
 * @version 1.0
 * @see Animation
 * @see FPSAnimation
 */
public interface AnimationPart {
  /**
   * This method will be called when the user wants to view this part
   * of the animation.
   */
  public void animate();
}