package vcp.platform;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import info.clearthought.layout.TableLayout;

/**
 * This is a GUI widget to dislay information about the VCP
 * application
 *
 * @author phil kaasa
 * @version 1.0
 */
public class About extends JPanel implements ActionListener {
  /** a picture of phil */
  public static ImageIcon PHIL = 
    new ImageIcon(About.class.getResource
          ("/vcp/platform/phil.jpg"));
  /** a picture of callie */
  public static ImageIcon CALLIE = 
    new ImageIcon(About.class.getResource
          ("/vcp/platform/callie.jpg"));

  /** the frame */
  JFrame frame;

  /** the OK button */
  JButton ok;

  /**
   * Creates a new <code>About</code> instance.
   */
  public About() {
    TableLayout tl;

    setLayout(tl = new TableLayout(new double[][]
      {{TableLayout.PREFERRED,
        TableLayout.FILL},
       {TableLayout.PREFERRED,
        TableLayout.PREFERRED,
        TableLayout.PREFERRED,}}));

    tl.setHGap(4);
    tl.setVGap(4);
    
    JTextArea philBio = new JTextArea("Phil Kaasa will graduate from Bethel University in 2006 with degrees in Computer Science and Philosophy and a minor in Mathematics. He plans to go to grad school for Computer Science within two years of graduating from Bethel. He has no idea what comes after that. In his free time, he enjoys being outside, listening to and playing music, fiddling with computers, and spending time with family and friends.");
    JTextArea callieBio = new JTextArea("Callie Wurtz is a senior math-education major at Bethel University. Her favorite math classes are Discrete Mathematics and Abstract Algebra. Though she likes learning about math, she has an even greater passion for helping others understand the subject. Led by this passion and a desire to follow God, Callie is planning to pursue a career in teaching math. Aside from mathematics, Callie enjoys basketball, reading novels, and playing board games with her five younger brothers and sisters. Originally from Wisconsin, Callie loves returning to the dairy state to spend time with her family.");

    philBio.setEditable(false);
    philBio.setLineWrap(true);
    philBio.setWrapStyleWord(true);
    callieBio.setEditable(false);
    callieBio.setLineWrap(true);
    callieBio.setWrapStyleWord(true);

    add(new JLabel(PHIL),"0,0");
    add(new JLabel(CALLIE),"0,1");
    add(new JScrollPane(philBio),"1,0");
    add(new JScrollPane(callieBio),"1,1");
    add(ok = new JButton("OK"),"0,2,1,2");
    ok.addActionListener(this);
    

    frame = new JFrame("About VCP");
    frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    frame.getContentPane().add(this);
    frame.pack();
    frame.setSize(new java.awt.Dimension(500,(int)frame.getSize().getHeight()));
    frame.validate();
    frame.setResizable(false);
    repaint();
  }

  /**
   * make the frame visible
   *
   * @param b a <code>boolean</code> value
   */
  public void setVisible(boolean b) {
    frame.setVisible(b);
  }

  public void actionPerformed(ActionEvent ev) {
    frame.setVisible(false);
  }
}
