package vcp.platform;

import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JEditorPane;
import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import vcp.utilities.ExceptionDialog;

/**
 * This is a GUI widget to dislay help information for the VCP
 * application
 *
 * @author phil kaasa
 * @version 1.0
 */
public class Help extends JPanel implements ActionListener {
  /** the frame */
  JFrame frame;

  /** OK button */
  JButton ok;

  /**
   * Creates a new <code>About</code> instance.
   */
  public Help() {
    super(new BorderLayout());

    StringBuffer sb = new StringBuffer();

    try {
      BufferedReader br = new BufferedReader
        (new InputStreamReader(Help.class.getResourceAsStream
                               ("/vcp/help.html")));
      
      String line;
      while((line = br.readLine()) != null)
        sb.append(line);
    } catch (Exception e) {
      ExceptionDialog.showExceptionDialog("yeah","stuff",e);
    }

    JEditorPane ep = new JEditorPane
      ("text/html",
       sb.toString()) {
        public void paintComponent(Graphics g) {
          Graphics2D g2d = (Graphics2D) g;

          g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
                               RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
          g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                               RenderingHints.VALUE_ANTIALIAS_ON);
          
          super.paintComponent(g2d);
        }
      };

    ep.setEditable(false);

    ok = new JButton("OK");
    ok.addActionListener(this);
    
    add(new JScrollPane(ep), BorderLayout.CENTER);
    
    ep.setCaretPosition(0);

    add(ok, BorderLayout.SOUTH);

    frame = new JFrame("VCP Help");
    frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    frame.getContentPane().add(this);
    frame.setSize(new Dimension(500,450));
  }

  public void setVisible(boolean b) {
    super.setVisible(b);

    frame.setVisible(b);
  }

  public void actionPerformed(ActionEvent ev) {
    frame.setVisible(false);
  }

  public static void main(String[] args) {
    (new Help()).setVisible(true);
  }
}