package vcp.platform;

/**
 * This represents a module.
 *
 * @author phil kaasa
 * @version 1.0
 */
public class Module extends java.util.Properties {
  String location;

  /**
   * Creates a new <code>Module</code> instance with default values
   * and the passed location.
   *
   * @param l the location of the module
   */
  public Module(String l) {
    super();

    setProperty("name","No Name");
    setProperty("abstract","No Abstract Found");
    setProperty("category","other");
    setProperty("author.exposition.name","Anonymous");
    setProperty("author.visualization.name","Anonymous");
    setProperty("author.exposition.contact","None Provided");
    setProperty("author.visualization.contact","Nine Provided");

    location = l;
    if(!location.endsWith("/"))
      location += "/";
  }

  public String toString() {
    return (getProperty("name"));
  }

  /**
   * Returns the location of the module
   *
   * @return the location of the module
   */
  public String getLocation() {
    return location;
  }
}