package vcp.platform;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.*;

import info.clearthought.layout.TableLayout;

/**
 * A GUI JPanel to be displayed in the main window when the
 * application first launches.
 *
 * @author phil kaasa
 * @version 1.0
 */
public class SplashGUI extends JPanel implements ActionListener {
  /** button to load a module */
  JButton loadModule;

  /** button to show intro to combinatorial proofs */
  JButton combinatorialIntro;

  /** button to show common definitions */
  JButton commonDefs;

  /** button to show info about the application */
  JButton aboutVCP;

  /**
   * Creates a new <code>SplashGUI</code> instance.
   */
  public SplashGUI() {
    super();

    TableLayout tl = new TableLayout
      (new double[][] {
        {TableLayout.FILL,
         TableLayout.FILL},
        {TableLayout.FILL,
         TableLayout.FILL},
      });

    tl.setHGap(8);
    tl.setVGap(8);

    setLayout(tl);
    
    loadModule = new JButton("Load Module");
    combinatorialIntro = new JButton("About Combinatorial Proofs");
    commonDefs = new JButton("View Common Definitions");
    aboutVCP = new JButton("About VCP");

    loadModule.addActionListener(this);
    combinatorialIntro.addActionListener(this);
    commonDefs.addActionListener(this);
    aboutVCP.addActionListener(this);

    add(loadModule,"0,0");
    add(combinatorialIntro,"1,0");
    add(commonDefs,"0,1");
    add(aboutVCP,"1,1");
  }

  /**
   * Handles button actions.
   *
   * @param e an <code>ActionEvent</code> value
   */
  public void actionPerformed(ActionEvent e) {
    JButton button = (JButton) e.getSource();


    if(button == loadModule) {
      GUIActions.loadModule();
    } else if(button == combinatorialIntro) {
      GUIActions.displayPDF
	("modules/definitions/CombProofIntro.pdf");
    } else if(button == commonDefs) {
      GUIActions.showBasicDefs();
    } else if(button == aboutVCP) {
      GUIActions.displayPDF
        ("modules/definitions/ProjectIntro.pdf");
    }
  }
}