package vcp.utilities;

import info.clearthought.layout.*;

/**
 * Extends TableLayout to include methods to get the pixel size of
 * rows and columns.
 *
 * @author phil kaasa
 * @version 1.0
 */
public class ExtendedTableLayout extends TableLayout {
  public ExtendedTableLayout(double[] c, double[] r) {
    super(c,r);
  }

  public ExtendedTableLayout(double[][] cr) {
    super(cr);
  }

  /**
   * Returns the size of a row in pixels
   *
   * @param i the index of the desired row
   * @return the size of a row in pixels
   */
  public int getRowPixels(int i) {
    return crSize[R][i];
  }
  /**
   * Returns the size of a column in pixels
   *
   * @param i the index of the desired row
   * @return the size of a column in pixels
   */
  public int getColumnPixels(int i) {
    return crSize[C][i];
  }

  /*
  public void addLayoutComponent(java.awt.Component comp, Object constraints) {
    System.out.println(javax.swing.SwingUtilities.isEventDispatchThread());
    super.addLayoutComponent(comp,constraints);
  }
  */
}