package vcp.utilities;

/**
 * This is an interface that can be implemented when using the 
 * {@link ScrollableTextArea} to make it easier for a class to reference
 * these flags if they are used often in the class's methods. This
 * interface defines no methods.
 *
 * @author phil kaasa
 * @version 1.0
 */
public interface ScrollableTextAreaConstants {
  /** A flag to indicate that the scroll mark should be set
   * <em>before</em> adding the contents.*/
  public static final int SET_MARK  = 0x1;

  /** A flag to indicate that the contents should be prepended by two
   * newline characters.*/
  public static final int NEWLINES  = 0x2;

  /** A flag to indicate that no update should be performed after
   * adding the contents.*/
  public static final int NO_UPDATE = 0x4;

  /** A flag to indicate that the scroll bar should be scrolled to the
   * scroll mark <em>after</em> adding the contents. */
  public static final int SCROLL    = 0x8;
}